package models

import (
	"database/sql/driver"
)

type BeingType string

const (
	BEING_HUMAN = BeingType("human")
	BEING_CAT   = BeingType("cat")
	BEING_FOX   = BeingType("fox")
	BEING_DOG   = BeingType("dog")
	BEING_ROBOT = BeingType("robot")
	BEING_DOLL  = BeingType("doll")
)

var AllBeings = []BeingType{BEING_HUMAN, BEING_CAT, BEING_FOX, BEING_DOG, BEING_ROBOT, BEING_DOLL}

func (ct *BeingType) Scan(value any) error {
	*ct = BeingType(value.([]byte))
	return nil
}

func (ct BeingType) Value() (driver.Value, error) {
	return string(ct), nil
}
